=== kcms/CMakeLists.txt ===
add_subdirectory(ldap)
