=== resources/shared/CMakeLists.txt ===
add_subdirectory(filestore)
add_subdirectory(singlefileresource)
